/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateMutableData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateMutableData{}

// CxTemplateMutableData struct for CxTemplateMutableData
type CxTemplateMutableData struct {
	Name *string `json:"name,omitempty"`
	HeaderImageUrls []CxTemplateMutableDataHeaderImageUrlsInner `json:"header_image_urls,omitempty"`
	Description *string `json:"description,omitempty"`
	Languages []string `json:"languages,omitempty"`
	Integrations *CxTemplateMutableDataIntegrations `json:"integrations,omitempty"`
	RequiredMessengers []string `json:"required_messengers,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Interactions []CxTemplateMutableDataInteractionsInner `json:"interactions,omitempty"`
	Global *bool `json:"global,omitempty"`
	Formality *string `json:"formality,omitempty"`
	PreviewUrls []CxTemplateMutableDataPreviewUrlsInner `json:"preview_urls,omitempty"`
}

// NewCxTemplateMutableData instantiates a new CxTemplateMutableData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateMutableData() *CxTemplateMutableData {
	this := CxTemplateMutableData{}
	return &this
}

// NewCxTemplateMutableDataWithDefaults instantiates a new CxTemplateMutableData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateMutableDataWithDefaults() *CxTemplateMutableData {
	this := CxTemplateMutableData{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CxTemplateMutableData) SetName(v string) {
	o.Name = &v
}

// GetHeaderImageUrls returns the HeaderImageUrls field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetHeaderImageUrls() []CxTemplateMutableDataHeaderImageUrlsInner {
	if o == nil || IsNil(o.HeaderImageUrls) {
		var ret []CxTemplateMutableDataHeaderImageUrlsInner
		return ret
	}
	return o.HeaderImageUrls
}

// GetHeaderImageUrlsOk returns a tuple with the HeaderImageUrls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetHeaderImageUrlsOk() ([]CxTemplateMutableDataHeaderImageUrlsInner, bool) {
	if o == nil || IsNil(o.HeaderImageUrls) {
		return nil, false
	}
	return o.HeaderImageUrls, true
}

// HasHeaderImageUrls returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasHeaderImageUrls() bool {
	if o != nil && !IsNil(o.HeaderImageUrls) {
		return true
	}

	return false
}

// SetHeaderImageUrls gets a reference to the given []CxTemplateMutableDataHeaderImageUrlsInner and assigns it to the HeaderImageUrls field.
func (o *CxTemplateMutableData) SetHeaderImageUrls(v []CxTemplateMutableDataHeaderImageUrlsInner) {
	o.HeaderImageUrls = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *CxTemplateMutableData) SetDescription(v string) {
	o.Description = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *CxTemplateMutableData) SetLanguages(v []string) {
	o.Languages = v
}

// GetIntegrations returns the Integrations field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetIntegrations() CxTemplateMutableDataIntegrations {
	if o == nil || IsNil(o.Integrations) {
		var ret CxTemplateMutableDataIntegrations
		return ret
	}
	return *o.Integrations
}

// GetIntegrationsOk returns a tuple with the Integrations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetIntegrationsOk() (*CxTemplateMutableDataIntegrations, bool) {
	if o == nil || IsNil(o.Integrations) {
		return nil, false
	}
	return o.Integrations, true
}

// HasIntegrations returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasIntegrations() bool {
	if o != nil && !IsNil(o.Integrations) {
		return true
	}

	return false
}

// SetIntegrations gets a reference to the given CxTemplateMutableDataIntegrations and assigns it to the Integrations field.
func (o *CxTemplateMutableData) SetIntegrations(v CxTemplateMutableDataIntegrations) {
	o.Integrations = &v
}

// GetRequiredMessengers returns the RequiredMessengers field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetRequiredMessengers() []string {
	if o == nil || IsNil(o.RequiredMessengers) {
		var ret []string
		return ret
	}
	return o.RequiredMessengers
}

// GetRequiredMessengersOk returns a tuple with the RequiredMessengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetRequiredMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.RequiredMessengers) {
		return nil, false
	}
	return o.RequiredMessengers, true
}

// HasRequiredMessengers returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasRequiredMessengers() bool {
	if o != nil && !IsNil(o.RequiredMessengers) {
		return true
	}

	return false
}

// SetRequiredMessengers gets a reference to the given []string and assigns it to the RequiredMessengers field.
func (o *CxTemplateMutableData) SetRequiredMessengers(v []string) {
	o.RequiredMessengers = v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *CxTemplateMutableData) SetTags(v []string) {
	o.Tags = v
}

// GetInteractions returns the Interactions field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetInteractions() []CxTemplateMutableDataInteractionsInner {
	if o == nil || IsNil(o.Interactions) {
		var ret []CxTemplateMutableDataInteractionsInner
		return ret
	}
	return o.Interactions
}

// GetInteractionsOk returns a tuple with the Interactions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetInteractionsOk() ([]CxTemplateMutableDataInteractionsInner, bool) {
	if o == nil || IsNil(o.Interactions) {
		return nil, false
	}
	return o.Interactions, true
}

// HasInteractions returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasInteractions() bool {
	if o != nil && !IsNil(o.Interactions) {
		return true
	}

	return false
}

// SetInteractions gets a reference to the given []CxTemplateMutableDataInteractionsInner and assigns it to the Interactions field.
func (o *CxTemplateMutableData) SetInteractions(v []CxTemplateMutableDataInteractionsInner) {
	o.Interactions = v
}

// GetGlobal returns the Global field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetGlobal() bool {
	if o == nil || IsNil(o.Global) {
		var ret bool
		return ret
	}
	return *o.Global
}

// GetGlobalOk returns a tuple with the Global field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetGlobalOk() (*bool, bool) {
	if o == nil || IsNil(o.Global) {
		return nil, false
	}
	return o.Global, true
}

// HasGlobal returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasGlobal() bool {
	if o != nil && !IsNil(o.Global) {
		return true
	}

	return false
}

// SetGlobal gets a reference to the given bool and assigns it to the Global field.
func (o *CxTemplateMutableData) SetGlobal(v bool) {
	o.Global = &v
}

// GetFormality returns the Formality field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetFormality() string {
	if o == nil || IsNil(o.Formality) {
		var ret string
		return ret
	}
	return *o.Formality
}

// GetFormalityOk returns a tuple with the Formality field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetFormalityOk() (*string, bool) {
	if o == nil || IsNil(o.Formality) {
		return nil, false
	}
	return o.Formality, true
}

// HasFormality returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasFormality() bool {
	if o != nil && !IsNil(o.Formality) {
		return true
	}

	return false
}

// SetFormality gets a reference to the given string and assigns it to the Formality field.
func (o *CxTemplateMutableData) SetFormality(v string) {
	o.Formality = &v
}

// GetPreviewUrls returns the PreviewUrls field value if set, zero value otherwise.
func (o *CxTemplateMutableData) GetPreviewUrls() []CxTemplateMutableDataPreviewUrlsInner {
	if o == nil || IsNil(o.PreviewUrls) {
		var ret []CxTemplateMutableDataPreviewUrlsInner
		return ret
	}
	return o.PreviewUrls
}

// GetPreviewUrlsOk returns a tuple with the PreviewUrls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableData) GetPreviewUrlsOk() ([]CxTemplateMutableDataPreviewUrlsInner, bool) {
	if o == nil || IsNil(o.PreviewUrls) {
		return nil, false
	}
	return o.PreviewUrls, true
}

// HasPreviewUrls returns a boolean if a field has been set.
func (o *CxTemplateMutableData) HasPreviewUrls() bool {
	if o != nil && !IsNil(o.PreviewUrls) {
		return true
	}

	return false
}

// SetPreviewUrls gets a reference to the given []CxTemplateMutableDataPreviewUrlsInner and assigns it to the PreviewUrls field.
func (o *CxTemplateMutableData) SetPreviewUrls(v []CxTemplateMutableDataPreviewUrlsInner) {
	o.PreviewUrls = v
}

func (o CxTemplateMutableData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateMutableData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.HeaderImageUrls) {
		toSerialize["header_image_urls"] = o.HeaderImageUrls
	}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.Integrations) {
		toSerialize["integrations"] = o.Integrations
	}
	if !IsNil(o.RequiredMessengers) {
		toSerialize["required_messengers"] = o.RequiredMessengers
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	if !IsNil(o.Interactions) {
		toSerialize["interactions"] = o.Interactions
	}
	if !IsNil(o.Global) {
		toSerialize["global"] = o.Global
	}
	if !IsNil(o.Formality) {
		toSerialize["formality"] = o.Formality
	}
	if !IsNil(o.PreviewUrls) {
		toSerialize["preview_urls"] = o.PreviewUrls
	}
	return toSerialize, nil
}

type NullableCxTemplateMutableData struct {
	value *CxTemplateMutableData
	isSet bool
}

func (v NullableCxTemplateMutableData) Get() *CxTemplateMutableData {
	return v.value
}

func (v *NullableCxTemplateMutableData) Set(val *CxTemplateMutableData) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateMutableData) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateMutableData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateMutableData(val *CxTemplateMutableData) *NullableCxTemplateMutableData {
	return &NullableCxTemplateMutableData{value: val, isSet: true}
}

func (v NullableCxTemplateMutableData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateMutableData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


